"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _getIterator2 = require("babel-runtime/core-js/get-iterator");

var _getIterator3 = _interopRequireDefault(_getIterator2);

var _slicedToArray2 = require("babel-runtime/helpers/slicedToArray");

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _map = require("babel-runtime/core-js/map");

var _map2 = _interopRequireDefault(_map);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var container = new _map2.default();
var callbacks = new _map2.default();

exports.default = {
  isLocked: function isLocked(id) {
    var count = container.get(id) || 0;
    return count > 0;
  },
  lock: function lock(id) {
    var count = container.get(id) || 0;
    container.set(id, ++count);
  },
  release: function release(id) {
    var count = container.get(id) || 0;
    if (count) {
      container.set(id, --count);
    }
    this.check();
  },
  check: function check() {
    var _iteratorNormalCompletion = true;
    var _didIteratorError = false;
    var _iteratorError = undefined;

    try {
      for (var _iterator = (0, _getIterator3.default)(callbacks), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
        var _ref = _step.value;

        var _ref2 = (0, _slicedToArray3.default)(_ref, 2);

        var id = _ref2[0];
        var callback = _ref2[1];

        var count = container.get(id);
        if (count === 0) {
          container.delete(id);
          callback();
        }
      }
    } catch (err) {
      _didIteratorError = true;
      _iteratorError = err;
    } finally {
      try {
        if (!_iteratorNormalCompletion && _iterator.return) {
          _iterator.return();
        }
      } finally {
        if (_didIteratorError) {
          throw _iteratorError;
        }
      }
    }
  },
  wait: function wait(id, callback) {
    callbacks.set(id, function () {
      callbacks.delete(id);
      callback();
    });
    this.check();
  }
};