'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.RenderService = undefined;

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

exports.default = preSSRService;

var _render = require('./render');

var _render2 = _interopRequireDefault(_render);

var _utils = require('./utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function getPathsFromRoutes(routes) {
  var paths = [];
  (0, _utils.searchRoutes)(routes, function (route) {
    paths.push(route.props.path);
  });
  return paths;
}

var RenderService = exports.RenderService = function () {
  function RenderService(_ref) {
    var url = _ref.url,
        interval = _ref.interval,
        renderOptions = _ref.renderOptions;
    (0, _classCallCheck3.default)(this, RenderService);

    this.url = url;
    this.timeout = interval;
    this.renderOptions = renderOptions;
  }

  (0, _createClass3.default)(RenderService, [{
    key: 'render',
    value: function () {
      var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee() {
        return _regenerator2.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.next = 2;
                return (0, _render2.default)(this.renderOptions);

              case 2:
                this.timer = setTimeout(this.run.bind(this), this.timeout);

              case 3:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function render() {
        return _ref2.apply(this, arguments);
      }

      return render;
    }()
  }, {
    key: 'run',
    value: function run() {
      this.render();
    }
  }, {
    key: 'stop',
    value: function stop() {
      if (this.timer) {
        clearTimeout(this.timer);
      }
    }
  }]);
  return RenderService;
}();

function preSSRService(_ref3) {
  var renderFullPage = _ref3.renderFullPage,
      createApp = _ref3.createApp,
      initialState = _ref3.initialState,
      _ref3$interval = _ref3.interval,
      interval = _ref3$interval === undefined ? 10000 : _ref3$interval,
      onRenderSuccess = _ref3.onRenderSuccess,
      routes = _ref3.routes,
      _ref3$timeout = _ref3.timeout,
      timeout = _ref3$timeout === undefined ? 6000 : _ref3$timeout,
      _ref3$verbose = _ref3.verbose,
      verbose = _ref3$verbose === undefined ? true : _ref3$verbose;

  var paths = getPathsFromRoutes(routes);
  paths.forEach(function (path) {
    new RenderService({
      url: path,
      interval: interval,
      renderOptions: {
        routes: routes,
        url: path,
        renderFullPage: renderFullPage,
        createApp: createApp,
        initialState: initialState,
        onRenderSuccess: onRenderSuccess,
        timeout: timeout,
        env: {
          platform: 'pc'
        },
        verbose: verbose
      }
    }).run();
    new RenderService({
      url: path,
      interval: interval,
      renderOptions: {
        routes: routes,
        url: path,
        renderFullPage: renderFullPage,
        createApp: createApp,
        initialState: initialState,
        onRenderSuccess: onRenderSuccess,
        timeout: timeout,
        env: {
          platform: 'mobile'
        },
        verbose: verbose
      }
    }).run();
  });
}