'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

var renderFragment = function () {
  var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(createApp, routes, url, initialState, timeout, staticMarkup, ignoreTimeout) {
    var asyncTime, isTimeout, render, history, context, app, asyncActions, branch, sync, id, _appDOM, isLocked, asyncStartTime, result, _html, _curState, appDOM, html, curState;

    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            asyncTime = 0;
            isTimeout = false;
            render = staticMarkup ? _server.renderToStaticMarkup : _server.renderToString;
            history = (0, _history.createMemoryHistory)();

            history.push(url);
            context = {};
            app = createApp({
              history: history,
              initialState: initialState
            });

            if (!existSSRModel(app)) {
              app.model(_ssrModel2.default);
            }
            app.router(function (options) {
              return _react2.default.createElement(
                _reactRouter.StaticRouter,
                { location: url, context: options.context },
                _react2.default.createElement(
                  'div',
                  null,
                  routes
                )
              );
            });
            asyncActions = getAsyncActions(app);
            branch = (0, _utils.findRouteByUrl)(routes, url);

            if (!(branch.length === 0)) {
              _context.next = 13;
              break;
            }

            return _context.abrupt('return', {});

          case 13:
            sync = findSync(branch);

            if (!(!sync && asyncActions && asyncActions.length > 0)) {
              _context.next = 36;
              break;
            }

            id = (0, _uid2.default)(10);

            app.use((0, _dvaServerSync2.default)(id, function (action) {
              if (asyncActions.indexOf(action.type) > -1) {
                return true;
              }
              return false;
            }, _block2.default));
            _appDOM = app.start()({
              context: context
            });
            isLocked = _block2.default.isLocked(id);

            if (!isLocked) {
              _context.next = 33;
              break;
            }

            asyncStartTime = Date.now();
            _context.prev = 21;
            _context.next = 24;
            return new _promise2.default(function (resolve, reject) {
              var timer = setTimeout(function () {
                reject(new Error('render timeout'));
              }, timeout);
              _block2.default.wait(id, function () {
                asyncTime = Date.now() - asyncStartTime;
                clearTimeout(timer);
                var curState = _appDOM.props.store.getState();
                var html = render(_appDOM);
                resolve({ html: html, state: curState, context: context, performance: {
                    asyncTime: asyncTime
                  } });
              });
            });

          case 24:
            result = _context.sent;
            return _context.abrupt('return', result);

          case 28:
            _context.prev = 28;
            _context.t0 = _context['catch'](21);

            isTimeout = true;

            if (ignoreTimeout) {
              _context.next = 33;
              break;
            }

            throw _context.t0;

          case 33:
            _html = render(_appDOM);
            _curState = _appDOM.props.store.getState();
            return _context.abrupt('return', { html: _html, state: _curState, context: context, performance: {
                asyncTime: asyncTime
              }, isTimeout: isTimeout });

          case 36:
            appDOM = app.start()({
              context: context
            });
            html = render(appDOM);
            curState = appDOM.props.store.getState();
            return _context.abrupt('return', { html: html, state: curState, context: context, performance: {
                asyncTime: asyncTime
              } });

          case 40:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this, [[21, 28]]);
  }));

  return function renderFragment(_x, _x2, _x3, _x4, _x5, _x6, _x7) {
    return _ref.apply(this, arguments);
  };
}();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _uid = require('uid');

var _uid2 = _interopRequireDefault(_uid);

var _reactRouter = require('react-router');

var _history = require('history');

var _lodash = require('lodash.merge');

var _lodash2 = _interopRequireDefault(_lodash);

var _server = require('react-dom/server');

var _ssrModel = require('./ssrModel');

var _ssrModel2 = _interopRequireDefault(_ssrModel);

var _utils = require('./utils');

var _dvaServerSync = require('./dvaServerSync');

var _dvaServerSync2 = _interopRequireDefault(_dvaServerSync);

var _block = require('./block');

var _block2 = _interopRequireDefault(_block);

var _config = require('./config');

var _dva = require('dva');

var _dva2 = _interopRequireDefault(_dva);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function existSSRModel(app) {
  try {
    var model = null;
    app._models.forEach(function (m) {
      if (m.namespace === 'ssr') {
        model = m;
      }
    });
    return !!model;
  } catch (e) {
    return false;
  }
}

function getAsyncActions(app) {
  try {
    var actions = [];
    app._models.forEach(function (model) {
      if (model.effects) {
        actions = actions.concat((0, _keys2.default)(model.effects));
      }
    });
    return actions;
  } catch (e) {
    return [];
  }
}

function findSync(branch) {
  var sync = false;
  branch.forEach(function (b) {
    sync = !!b.props.sync;
  });
  return sync;
}

exports.default = function () {
  var _ref3 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2(_ref2) {
    var url = _ref2.url,
        env = _ref2.env,
        routes = _ref2.routes,
        renderFullPage = _ref2.renderFullPage,
        createApp = _ref2.createApp,
        initialState = _ref2.initialState,
        onRenderSuccess = _ref2.onRenderSuccess,
        _ref2$models = _ref2.models,
        models = _ref2$models === undefined ? [] : _ref2$models;
    var config, startTime, state, fragment, context, html;
    return _regenerator2.default.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            config = (0, _config.getConfig)();
            _context2.prev = 1;
            startTime = Date.now();
            state = (0, _lodash2.default)({}, initialState || {}, {
              ssr: {
                env: env
              }
            });

            if (!createApp) {
              createApp = function createApp(opts) {
                var app = (0, _dva2.default)(opts);
                models.forEach(function (model) {
                  app.model(model);
                });
                return app;
              };
            }
            _context2.next = 7;
            return renderFragment(createApp, routes, url, state, config.timeout, config.staticMarkup, config.ignoreTimeout, models);

          case 7:
            fragment = _context2.sent;
            context = fragment.context;

            if (context) {
              _context2.next = 14;
              break;
            }

            if (config.verbose || config.__DEV__) {
              console.log('fail to match url \'' + url + '\', please check routes', env);
            }
            return _context2.abrupt('return', { code: 404, url: url, env: env });

          case 14:
            if (!context.url) {
              _context2.next = 19;
              break;
            }

            if (config.verbose || config.__DEV__) {
              console.log('redirect to url \'' + context.url + '\'', env);
            }
            _context2.next = 18;
            return render({
              url: context.url, env: env, routes: routes, renderFullPage: renderFullPage, createApp: createApp, initialState: initialState, onRenderSuccess: onRenderSuccess
            });

          case 18:
            return _context2.abrupt('return', _context2.sent);

          case 19:
            html = fragment.html;

            if (!renderFullPage) {
              _context2.next = 24;
              break;
            }

            _context2.next = 23;
            return renderFullPage(fragment);

          case 23:
            html = _context2.sent;

          case 24:
            if (fragment.isTimeout) {
              console.log('render url \'' + url + '\' timeout', env);
            } else if (config.verbose || config.__DEV__) {
              console.log('render url \'' + url + '\' success in ' + (Date.now() - startTime) + ' ms', env);
              if (fragment.performance.asyncTime) {
                console.log('async time: ' + fragment.performance.asyncTime + ' ms\n');
              }
            }

            if (!onRenderSuccess) {
              _context2.next = 28;
              break;
            }

            _context2.next = 28;
            return onRenderSuccess({
              html: html, url: url, env: env, state: fragment.state
            });

          case 28:
            return _context2.abrupt('return', {
              code: 200, url: url, env: env, html: html
            });

          case 31:
            _context2.prev = 31;
            _context2.t0 = _context2['catch'](1);

            console.log('render url \'' + url + '\' error', env);
            console.error(_context2.t0);
            return _context2.abrupt('return', {
              code: 500, url: url, env: env, error: _context2.t0
            });

          case 36:
          case 'end':
            return _context2.stop();
        }
      }
    }, _callee2, this, [[1, 31]]);
  }));

  function render(_x8) {
    return _ref3.apply(this, arguments);
  }

  return render;
}();