'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

exports.default = runtimeSSRMiddle;

var _mobileDetect = require('mobile-detect');

var _mobileDetect2 = _interopRequireDefault(_mobileDetect);

var _render = require('./render');

var _render2 = _interopRequireDefault(_render);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function runtimeSSRMiddle(_ref) {
  var _this = this;

  var routes = _ref.routes,
      renderFullPage = _ref.renderFullPage,
      createApp = _ref.createApp,
      initialState = _ref.initialState,
      onRenderSuccess = _ref.onRenderSuccess,
      models = _ref.models;

  return function () {
    var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(req, res, next) {
      var isMobile, result;
      return _regenerator2.default.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              isMobile = !!new _mobileDetect2.default(req.headers['user-agent']).mobile();
              _context.next = 3;
              return (0, _render2.default)({
                url: req.url,
                env: { platform: isMobile ? 'mobile' : 'pc' },
                routes: routes,
                renderFullPage: renderFullPage,
                createApp: createApp,
                initialState: initialState,
                onRenderSuccess: onRenderSuccess,
                models: models
              });

            case 3:
              result = _context.sent;
              _context.t0 = result.code;
              _context.next = _context.t0 === 200 ? 7 : _context.t0 === 302 ? 8 : _context.t0 === 404 ? 9 : _context.t0 === 500 ? 11 : 13;
              break;

            case 7:
              return _context.abrupt('return', res.end(result.html));

            case 8:
              return _context.abrupt('return', res.redirect(302, result.redirect));

            case 9:
              next();
              return _context.abrupt('break', 15);

            case 11:
              next(result.error);
              return _context.abrupt('break', 15);

            case 13:
              next();
              return _context.abrupt('break', 15);

            case 15:
            case 'end':
              return _context.stop();
          }
        }
      }, _callee, _this);
    }));

    return function (_x, _x2, _x3) {
      return _ref2.apply(this, arguments);
    };
  }();
}