'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof2 = require('babel-runtime/helpers/typeof');

var _typeof3 = _interopRequireDefault(_typeof2);

exports.searchRoutes = searchRoutes;
exports.findRouteByUrl = findRouteByUrl;

var _reactRouter = require('react-router');

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function isArray(element) {
  return Object.prototype.toString.call(element) === '[object Array]';
}

function searchRoutes(r, callback) {
  function searchPaths(routes) {
    if (isArray(routes)) {
      routes.forEach(function (route) {
        searchPaths(route);
      });
    }
    if ((typeof routes === 'undefined' ? 'undefined' : (0, _typeof3.default)(routes)) === 'object' && routes.props && routes.props.children) {
      _react2.default.Children.forEach(routes.props.children, function (route) {
        searchPaths(route);
      });
    }
    if ((typeof routes === 'undefined' ? 'undefined' : (0, _typeof3.default)(routes)) === 'object' && routes.props && routes.props.path) {
      callback(routes);
    }
  }
  searchPaths(r);
}

function findRouteByUrl(routes, url) {
  var rtn = [];
  var queryIndex = url.indexOf('?');
  if (queryIndex > -1) {
    url = url.slice(0, queryIndex);
  }
  if (url.length > 1 && url[url.length - 1] === '/') {
    url = url.slice(0, -1);
  }
  searchRoutes(routes, function (route) {
    var match = (0, _reactRouter.matchPath)(url, route.props);
    if (match) {
      rtn.push(route);
    }
  });
  return rtn;
}